########## PCA

source("./library.R")
source("./color_theme.R")
#####metadata: contain library, sample and batch columns

pcavalues<-function(datalist,metadata){

library(scales)
library(stringr)

pcavalue<-c()

for ( a in 1:length(datalist)){
  print(a)
  print(datalist[a])
  eval(parse(text=paste("exprMat<-readRDS(\"./",datalist[a],"\")",sep="")))
  
  raw<-exprMat
  raw<-raw[apply(raw,1,function(x){length(which(is.na(x)))==0}),]
   
  sample<-as.character(metadata$sample[match(colnames(raw),metadata$library)])
  batch<-as.character(metadata$batch[match(colnames(raw),metadata$library)])
  
  dat_z<-t(apply(raw,1,function(x){(x-mean(x))/sd(x)}))
  dat_z<-dat_z[apply(dat_z,1,function(x){length(which(is.na(x)))==0}),]
  
  ###########PCA 
  
  pca_prcomp <- prcomp(t(dat_z), scale=F,retx=T)
 
  pcs <- data.frame(predict(pca_prcomp))[,1:3]
  pcs$library<-rownames(pcs)
  pcs$sample =sample
  pcs$batch =batch
  pcs$filename<-datalist[a]
  pcs$PC1comp<- summary(pca_prcomp)$importance[2,1]*100
  pcs$PC2comp<-summary(pca_prcomp)$importance[2,2]*100
  
  pcavalue<-rbind(pcavalue,pcs)
}

##rescale
pcavalue_rescale<-c()

uu<-datalist

for ( i in 1:length(uu)){
  pcs<-pcavalue[pcavalue$filename==uu[i],]
  
  pcs$PC1_res<-rescale(pcs$PC1,c(-100,100))
  pcs$PC2_res<-rescale(pcs$PC2,c(-100,100))
  pcs$PC3_res<-rescale(pcs$PC3,c(-100,100))
 
  pcavalue_rescale<-rbind(pcavalue_rescale,pcs)
	}
	
	
return(pcavalue_rescale)
}


plot_PCA<-function(pcavalue_rescale){

########plot

pca_plot<- ggplot(pcavalue_rescale),aes(x=PC1_res,y=PC2_res,color=sample))+
  geom_point(aes(color=sample,shape=batchid),size=2)+
  scale_color_manual(values = colors.type.quartet3,name="Sample") +
  scale_shape_manual(values=c(0:15),name="Batch")+
  theme_few()+
  mytheme12+
  facet_grid(.~filename,scales="free",space = "free",switch = "y")+
  theme(axis.text.x = element_blank(),
        axis.text.y=element_blank(),
        axis.ticks = element_blank(),
        strip.text = element_text(size=13),
        legend.title = element_text(size=14),
        legend.text = element_text(size=12))+
  labs(x="",y="")
  
return(pca_plot)
}

