#########cal kBET
source("./library.R")


library(kBET)
library(FNN)

#####metadata: contain library, sample and batch columns

kBET_cal<-function(datalist, metadata){

kbetall<-c()
for ( a in 1:length(datalist)){

  eval(parse(text=paste("exprMat<-readRDS(\"./",datalist[a],"\")",sep="")))
    
  usample<-unique(as.character(metadata$sample))
	
  for ( i in 1:length(usample)){
    meta_mat_s<-metadata[ metadata$sample== usample[i],]
	lib<-as.character(meta_mat_s$library)
    raw<-exprMat[,colnames(exprMat) %in% lib]
    sample_s<-as.character(metadata$sample[match(colnames(raw),meta_mat$library)])
    batch_s<-as.factor(as.character(meta_mat$batch[match(colnames(raw),meta_mat$library)]))
  
  data<-t(as.matrix(raw))
  
  # data: a matrix (rows: samples, columns: features (genes))
  k0=floor(mean(table(batch_s))) #neighbourhood size: mean batch size 
  knn <- get.knn(data, k=k0, algorithm = 'cover_tree')
  
  #now run kBET with pre-defined nearest neighbours.
  batch.estimate <- kBET(data, batch_s, k = k0, knn = knn,plot=F)
  kBET_acc_value<-(1-batch.estimate$summary$kBET.observed[1])
  kBET_sig<-batch.estimate$summary$kBET.signif[1]
  
  kbetall<-rbind(kbetall,c(datalist[a],usample[i],kBET_acc_value,kBET_sig))
  }
  
}


kbetall<-data.frame(kbetall)
colnames(kbetall)<-c("filename","sample","kBET_acc_value","kBET_sig")
kbetall$kBET_acc_value<-as.numeric(as.character(kbetall$kBET_acc_value))
kbetall$kBET_sig<-as.numeric(as.character(kbetall$kBET_sig))

return(kbetall)
}


